# coding: utf-8

"""
    Form Service API

    A list of form and Xaas APIs.  This page describes the RESTful APIs for Form Service. The APIs facilitate CRUD operations on the various resources and entities used throughout Form service (Custom Resource , Form Definition etc.) and allow operations on them (creating custom resource type , fetch form status etc.).  Some of the APIs that list collections of resources also support OData like implementation. Below query params can be used across Form and XaaS entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/form-service/api/custom/resource-types?$orderby=name%20DESC```  2. `page`, `size` - page used in conjunction with `size` helps in pagination of resources.      ```/form-service/api/custom/resource-types?page=0&size=20```   # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InlineResponse2001(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'form_id': 'str',
        'source_type': 'str',
        'source_id': 'str',
        'type': 'str',
        'status': 'str'
    }

    attribute_map = {
        'form_id': 'formId',
        'source_type': 'sourceType',
        'source_id': 'sourceId',
        'type': 'type',
        'status': 'status'
    }

    def __init__(self, form_id=None, source_type=None, source_id=None, type=None, status=None):  # noqa: E501
        """InlineResponse2001 - a model defined in Swagger"""  # noqa: E501
        self._form_id = None
        self._source_type = None
        self._source_id = None
        self._type = None
        self._status = None
        self.discriminator = None
        if form_id is not None:
            self.form_id = form_id
        if source_type is not None:
            self.source_type = source_type
        if source_id is not None:
            self.source_id = source_id
        if type is not None:
            self.type = type
        if status is not None:
            self.status = status

    @property
    def form_id(self):
        """Gets the form_id of this InlineResponse2001.  # noqa: E501


        :return: The form_id of this InlineResponse2001.  # noqa: E501
        :rtype: str
        """
        return self._form_id

    @form_id.setter
    def form_id(self, form_id):
        """Sets the form_id of this InlineResponse2001.


        :param form_id: The form_id of this InlineResponse2001.  # noqa: E501
        :type: str
        """

        self._form_id = form_id

    @property
    def source_type(self):
        """Gets the source_type of this InlineResponse2001.  # noqa: E501


        :return: The source_type of this InlineResponse2001.  # noqa: E501
        :rtype: str
        """
        return self._source_type

    @source_type.setter
    def source_type(self, source_type):
        """Sets the source_type of this InlineResponse2001.


        :param source_type: The source_type of this InlineResponse2001.  # noqa: E501
        :type: str
        """

        self._source_type = source_type

    @property
    def source_id(self):
        """Gets the source_id of this InlineResponse2001.  # noqa: E501


        :return: The source_id of this InlineResponse2001.  # noqa: E501
        :rtype: str
        """
        return self._source_id

    @source_id.setter
    def source_id(self, source_id):
        """Sets the source_id of this InlineResponse2001.


        :param source_id: The source_id of this InlineResponse2001.  # noqa: E501
        :type: str
        """

        self._source_id = source_id

    @property
    def type(self):
        """Gets the type of this InlineResponse2001.  # noqa: E501


        :return: The type of this InlineResponse2001.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this InlineResponse2001.


        :param type: The type of this InlineResponse2001.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def status(self):
        """Gets the status of this InlineResponse2001.  # noqa: E501


        :return: The status of this InlineResponse2001.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this InlineResponse2001.


        :param status: The status of this InlineResponse2001.  # noqa: E501
        :type: str
        """
        allowed_values = ["OFF", "ON", "INVALID", "GENERATED"]  # noqa: E501
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InlineResponse2001, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InlineResponse2001):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
